#ifndef MAINWIDGET_H
#define MAINWIDGET_H

#include <QWidget>
#include <QTableWidget>
#include <QMessageBox>
#include "src/xml_opr.h"
#include "src/config.h"

QT_BEGIN_NAMESPACE
namespace Ui {
class MainWidget;
}
QT_END_NAMESPACE

class MainWidget : public QWidget
{
    Q_OBJECT

public:
    MainWidget(QWidget* parent = nullptr);
    ~MainWidget();

public:
    void set_work_exe(char* path);
    void generate_table_widget();
    void push_content(const std::vector<tinyxml2::XMLElement*>& eles);

private:
    void read();
    void search();
    void item_changed_handle(QTableWidgetItem *item);
    void save();
private:
    Ui::MainWidget*                    ui;
    ConfigIni                          ini_{};
    CXmlOpr                            xml_{};
    std::string                        exe_path_{};
    QTableWidget*                      tab_widget_{};
    std::vector<tinyxml2::XMLElement*> vec_{};
    std::vector<tinyxml2::XMLElement*> current_{};
    std::vector<std::string>           keys_{};
    std::vector<int>                   width_{};
    bool                               auto_add_{false};
};
#endif   // MAINWIDGET_H
